            TTL Program Title for Listing Header Goes Here
;****************************************************************
; Lab 12: Project : Binary to hex training game 
;(What does the program do?)
;Name:  <Your name here>
;Date:  <Date completed here>
;Class:  CMPE-250
;Section:  <Your lab section, day, and time here>
;---------------------------------------------------------------
;Keil Template for KL46 Assembly with Keil C startup
;R. W. Melton
;November 13, 2017
;****************************************************************
;Assembler directives
            THUMB
            GBLL  MIXED_ASM_C
MIXED_ASM_C SETL  {TRUE}
            OPT   64  ;Turn on listing macro expansions
;****************************************************************
;Include files
            GET  MKL46Z4.s     ;Included by start.s
            OPT  1   ;Turn on listing
;****************************************************************
;EQUates
            GET     Exercise12_EQU.s
;****************************************************************
;MACROs

            GET     Macros.s 

;****************************************************************
;Program
;C source will contain main ()
;Only subroutines and ISRs in this assembly source
;export subroutines to be use in C source here
            AREA    MyCode,CODE,READONLY
            ; dependent subroutines are imported using SubroutineDependencies.s file 

;>>>>> begin subroutine code <<<<<
    ;todo: write subroutines to init GPIOs
    
    EXPORT      StartStopWatch
StartStopWatch          PROC {R0-R13}
    PUSH     {R0,R1}   
    ;start the PIT timer stopwatch
    LDR     R0,=RunStopWatch
    MOVS    R1,#1
    STRB    R1,[R0,#0]                      ; set RunStopWatch to 1
    POP     {R0,R1}
    BX      LR
    ENDP

    EXPORT      PauseStopWatch
PauseStopWatch          PROC {R1-R13}
    ;pauses the stop watch 
    ;returns the current stop watch count in R0

    PUSH     {R1}

    ;stop the PIT timer stopwatch
    LDR     R0,=RunStopWatch
    MOVS    R1,#0
    STRB    R1,[R0,#0]                      ; set RunStopWatch to 0
    ;get the current count
    LDR     R0,=Count
    LDR     R0,[R0,#0]
    ;return the count in R0
    POP     {R1}
    BX      LR
    ENDP

    EXPORT      GetStopWatchCountAddress
GetStopWatchCountAddress      PROC {R1-R13}
    ;returns the address of the stop watch count in R0
    LDR     R0,=Count
    BX      LR
    ENDP


    EXPORT      initBinaryLEDs
initBinaryLEDs          PROC    {R0-R13}
; Description: 
;   set up KL46Z pins as GPIOs for off-board LEDs on the FDRM-KL46Z development board
;   configure cpu pins as GPIOs
;   configure gpio pins as outputs
;   set gpio pins to 0
;   note: must run init onboard LEDs first to set up clocking for port E
;   LED 0 (LSB) is between PTE19 and 3v3
;   LED 1       is between PET17 and 3v3
;   LED 2       is between PET06 and GND 
;   LED 3 (MSB) is between PET03 and GND
        PUSH        {R0-R2}
        
    ; set pins for gpio (alt 1) = mux select
        LDR     R2,=PORT_PCR_MUX_SELECT_1_MASK      ; mask for gpio mode 
        ;LED 0
        LDR     R0,=PORTE_PCR19
        STR     R2,[R0,#0]
        ; LED 1
        LDR     R0,=PORTE_PCR17
        STR     R2,[R0,#0]                 
        ; LED 2
        LDR     R0,=PORTE_PCR6
        STR     R2,[R0,#0]  
        ; LED 3
        LDR     R0,=PORTE_PCR3
        STR     R2,[R0,#0]  
    ;set pins to output
        LDR     R0,=GPIOE_PDDR
        LDR     R1,[R0,#0]
        ; mask for output direction on pin 3,6,17,19 = 00000000'00001010'00000000'01001000 = 0x_00'0A'00'48 = 0x000A0048
        LDR     R2,=0x000A0048
        ORRS    R1,R1,R2
        STR     R1,[R0,#0]

        POP     {R0-R2}
        BX      LR
        ENDP


    EXPORT      writeToBinaryLEDs
writeToBinaryLEDs          PROC    {R0-R13}
; Description:
;   writes the LSByte of R0 to the binary LED
;   R0:
;   LED 0 (LSB) state = bit 0 of R0
;   LED 1       state = bit 1 of R0   
;       0 = LED on, 1 = LED off 

;   LED 2       state = bit 2 of R0
;   LED 3 (MSB) state = bit 3 of R0
;       0 = LED off, 1 = LED on
;   HW:
;   LED 0 (LSB) is between PTE19 and 3v3
;   LED 1       is between PET17 and 3v3
;   LED 2       is between PET06 and GND 
;   LED 3 (MSB) is between PET03 and GND

; Inputs:
;   R0 - LSByte to write to binary LEDs
; Outputs:
;   none
; Intermediate Registers:
;   R1 - temp bit, control register value
;   R2 -  LED pin Masks
;   R3 -  control register address
;   

        PUSH    {R0-R4}


    ;LED0 
writeToBinaryLEDs_LED0
        ; get desired led 0 state (on/off) into R1 LSbit
        MOVS    R1,R0
        MOVS    R2,#0x01        ; lsbit mask
        ANDS    R1,R1,R2
        LDR     R2,=0x00080000                  ; mask for LED 0 (PTE19) = 00000000'00001000'00000000'00000000
        BEQ     writeToBinaryLEDs_LED0_Off        ; if R1 == 0 then turn LED0 off
        ;BNE     writeToBinaryLEDs_LED0_On        ; if R1 != 0 then turn LED0 on
writeToBinaryLEDs_LED0_On       
        ; write a 0 to led0 - using GPIOE_PCOR
        LDR     R3,=GPIOE_PCOR
        B       writeToBinaryLEDs_LED0_Write  ; done selecting to clear or set, now write
writeToBinaryLEDs_LED0_Off
        ; write a 1 to led0 - using GPIOE_PSOR
        LDR     R3,=GPIOE_PSOR
        ;B       writeToBinaryLEDs_LED0_Write  ; done selecting to clear or set, now write
writeToBinaryLEDs_LED0_Write
        LDR     R4,[R3,#0]                      ; load in current Port E Set OR Clear Output Register value
        ORRS    R4,R4,R2                        ; write 0 to led0 by orring in the positive mask to the CLEAR register 
        STR     R4,[R3,#0]                      ; write the new Port E Clear value to the control register
       ; B       writeToBinaryLEDs_LED1  ; done setting, branch to next LED 


    ;LED1
writeToBinaryLEDs_LED1
        ; get desired led 0 state (on/off) into R1 LSbit
        LSRS    R0,R0,#1        ; shift R0 to the left by 1 to get LED 1
        MOVS    R2,#0x01        ; LSbit mask
        MOVS    R1,R0           ; move R0 into R1 so we can use ands with R1,R1
        ANDS    R1,R1,R2        ; R1 now only has LED 1 state
        LDR     R2,=0x00020000                  ; mask for LED 1 (PET17) = 00000000'00000010'00000000'00000000
        BEQ     writeToBinaryLEDs_LED1_Off        ; if R1 == 0 then turn LED1 off
writeToBinaryLEDs_LED1_On       
        ; write a 0 to LED 1 - using GPIOE_PCOR
        LDR     R3,=GPIOE_PCOR
        B       writeToBinaryLEDs_LED1_Write  ; done selecting to clear or set, now write
writeToBinaryLEDs_LED1_Off
        ; write a 1 to led 1 - using GPIOE_PSOR
        LDR     R3,=GPIOE_PSOR
        ;B       writeToBinaryLEDs_LED1_Write  ; done selecting to clear or set, now write
writeToBinaryLEDs_LED1_Write
        LDR     R4,[R3,#0]                      ; load in current Port E Set OR Clear Output Register value
        ORRS    R4,R4,R2                      ; write 0 to led0 by orring in the positive mask to the CLEAR register 
        STR     R4,[R3,#0]                      ; write the new Port E Clear value to the control register
       ; B       writeToBinaryLEDs_LED2  ; done setting, branch to next LED 


    ;LED2
writeToBinaryLEDs_LED2
        ; get desired LED 2 state (on/off) into R1 LSbit
        LSRS    R0,R0,#1        ; shift R0 to the left by 1 to get LED 2
        MOVS    R2,#0x01        ; LSbit mask
        MOVS    R1,R0           ; move R0 into R1 so we can use ands with R1,R1
        ANDS    R1,R1,R2        ; R1 now only has LED 2 state
        LDR     R2,=0x00000040                  ; mask for LED 2 (PET06) = 00000000'00000000'00000000'01000000
        BEQ     writeToBinaryLEDs_LED2_Off        ; if R1 == 0 then turn LED1 off
writeToBinaryLEDs_LED2_On       
        ; write a 1 to LED 2 - using GPIOE_PCOR
        LDR     R3,=GPIOE_PSOR
        B       writeToBinaryLEDs_LED2_Write  ; done selecting to clear or set, now write
writeToBinaryLEDs_LED2_Off
        ; write a 0 to led 2 - using GPIOE_PSOR
        LDR     R3,=GPIOE_PCOR
        ;B       writeToBinaryLEDs_LED2_Write  ; done selecting to clear or set, now write
writeToBinaryLEDs_LED2_Write
        LDR     R4,[R3,#0]                      ; load in current Port E Set OR Clear Output Register value
        ORRS    R4,R4,R2                      ; write 0 to led0 by orring in the positive mask to the CLEAR register 
        STR     R4,[R3,#0]                      ; write the new Port E Clear value to the control register
       ; B       writeToBinaryLEDs_LED3  ; done setting, branch to next LED 



    ;LED3
writeToBinaryLEDs_LED3
        ; get desired LED 3 state (on/off) into R1 LSbit
        LSRS    R0,R0,#1        ; shift R0 to the left by 1 to get LED 3
        MOVS    R2,#0x01        ; LSbit mask
        MOVS    R1,R0           ; move R0 into R1 so we can use ands with R1,R1
        ANDS    R1,R1,R2        ; R1 now only has LED 3 state
        LDR     R2,=0x00000008                  ; mask for LED 3 (PET03) = 00000000'00000000'00000000'00001000
        BEQ     writeToBinaryLEDs_LED3_Off        ; if R1 == 0 then turn LED1 off
writeToBinaryLEDs_LED3_On       
        ; write a 1 to LED 3 - using GPIOE_PCOR
        LDR     R3,=GPIOE_PSOR
        B       writeToBinaryLEDs_LED3_Write  ; done selecting to clear or set, now write
writeToBinaryLEDs_LED3_Off
        ; write a 0 to led 3 - using GPIOE_PSOR
        LDR     R3,=GPIOE_PCOR
        ;B       writeToBinaryLEDs_LED3_Write  ; done selecting to clear or set, now write
writeToBinaryLEDs_LED3_Write
        LDR     R4,[R3,#0]                      ; load in current Port E Set OR Clear Output Register value
        ORRS    R4,R4,R2                      ; write 0 to led0 by orring in the positive mask to the CLEAR register 
        STR     R4,[R3,#0]                      ; write the new Port E Clear value to the control register
       ; B       writeToBinaryLEDs_LED_END  ; done setting, branch to next LED 



        POP     {R0-R4}
        BX      LR
        ENDP

        
	
	ALIGN
    LTORG
;todo consider moving these to a separate file - LED subroutines. Check if this will be a debugging issue
    EXPORT          initOnboardLEDs
initOnboardLEDs         PROC  {R0-R13}
; Description: 
;   set up KL46Z pins as GPIOs for onboard LEDs on the FDRM-KL46Z development board
;   configure cpu pins as GPIOs
;   configure gpio pins as outputs
;   set gpio pins to 0

        PUSH        {R0-R2}

    ; q: why do i not have to select a clock to use for port d and e?

    ;connect clock for Port D 
    LDR     R0,=SIM_SCGC5
    LDR     R1,[R0,#0]                  ; load system intergration module system clock gating control register 5 value into r0
    LDR     R2,=SIM_SCGC5_PORTD_MASK    ; mask for port D clock enable bit
    ORRS     R1,R1,R2                    ; set port D clock enable bit in SIM_SCGC5 connecting clock to port D
    STR     R1,[R0,#0]                  ; store modified value back into SIM_SCGC5

    ;connect clock for Port E
    ;LDR         R0,=SIM_SCGC5
    LDR     R1,[R0,#0]                  ; load system intergration module system clock gating control register 5 value into r0
    LDR     R2,=SIM_SCGC5_PORTE_MASK    ; mask for port E clock enable bit
    ORRS     R1,R1,R2                    ; set port E clock enable bit in SIM_SCGC5 connecting clock to port E
    STR     R1,[R0,#0]                  ; store modified value back into SIM_SCGC5


    ;acronym notes:
        ; PTxn = Port x, Pin n
        ; PORTx_PCRn = Port x Pin Control Register n

    ; Pin Control Register (PCR) mux notes:
        ; PORTx_PCRn bits 8-10 define the MUX control for the pin n in port x. 000 = disabled, 001 = alt 1 (GPIO), 010 = alt 2, 011 = alt 3 ...
        ; PORT_PCR_MUX_SELECT_1_MASK  EQU  0x00000100 = 00000000'00000000'00000001'00000000, sets to alt 1 (GPIO)
        ; see KL46z reference manual, section 11.5.1 (pg. 193) for more details

    ; Port Data Direction Register (PDDR) notes 
        ; PORTx_PDDRn = Port x Pin Data Direction Register n
        ; PORTx_PDDRn bit n = 0 = input, 1 = output
        ; see KL46z reference manual, section 42.2.6 (pg. 837) for more details

    ; Green LED Config:
        ;Green LED is connected to KL46Z (chip) Pin #98 via dev board PCB. This connection is also routed to J2 pin #12
        ;KL46Z (chip) Pin #98 should be configured as GPIO. This is done via KL46z Pin Muxing. We are using ALT 1 (Port D Pin 5 (PTD5))
        ; Select PTD5 function for KL46Z Pin #98 
        LDR     R0,=PORTD_PCR5
        LDR     R1,[R0,#0]                      ; load in current Port D Pin Control Register 1 value
        LDR     R2,=PORT_PCR_MUX_SELECT_1_MASK  ; mask to select alt mode 1 (GPIO)
        ORRS    R1,R1,R2                        ; set the MUX bits in PortD PCR to alt 1 (GPIO)
        STR     R1,[R0,#0]                      ; store back to Port D Pin Control Register 1
        ; set the GPIO direction for PTD5 (Green LED) to output using GPIOx_PDDR5
        LDR     R0,=GPIOD_PDDR
        LDR     R1,[R0,#0]                      ; load in current Port D Pin Direction Register value
        MOVS    R2,#0x20                         ; mask to set the direction bit for pin #5 (PTD5) to output = 00000000'00000000'00000000'00100000 = 0x20 = 32
        ORRS    R1,R1,R2                        ; set the direction bit for pin #5 (PTD5) to output
        STRB    R1,[R0,#0]                      ; store back to Port D Pin Direction Register

    ; Red LED Config:
        ;Red LED is connected to KL46Z (chip) Pin #26 via dev board PCB. This connection is NOT routed to a header
        ;KL46Z (chip) Pin #98 should be configured as GPIO. This is done via KL46z Pin Muxing. We are using ALT1 (Port E Pin 29 (PTE29))
        ; Select PTE29 function for KL46Z Pin #26 
        LDR     R0,=PORTE_PCR29
        LDR     R1,[R0,#0]                      ; load in current Port E Pin Control Register 1 value
        LDR     R2,=PORT_PCR_MUX_SELECT_1_MASK  ; mask to select alt mode 1 (GPIO)
        ORRS     R1,R1,R2                        ; set the MUX bits in PortE PCR to alt 1 (GPIO)
        STR     R1,[R0,#0]                      ; store back to Port E Pin Control Register 1
        ; set the GPIO direction for PTE29 (Red LED) to output using GPIOx_PDDR
        LDR     R0,=GPIOE_PDDR
        LDR     R1,[R0,#0]                      ; load in current Port E Pin Direction Register value
        LDR     R2,=0x20000000                  ; mask to set the direction bit for pin #29 (PTE29) to output = 00100000'00000000'00000000'00000000 = 0x20000000
        ORRS    R1,R1,R2                        ; set the direction bit for pin #29 (PTE29) to output
        STR     R1,[R0,#0]                      ; store back to Port E Pin Direction Register

        POP       {R0-R2}
        BX      LR
        ENDP


; test subroutine to simplify testing of the LED. Just init and set pin to high. 
    EXPORT  initLED0
initLED0        PROC    {R0-R13}
        ;   LED 0 (LSB) is between PTE19 and 3v3
    ;connect clock for Port E
        PUSH        {R0-R2}

        LDR     R0,=SIM_SCGC5
        LDR     R1,[R0,#0]                  ; load system intergration module system clock gating control register 5 value into r0
        LDR     R2,=SIM_SCGC5_PORTE_MASK    ; mask for port E clock enable bit
        ORRS    R1,R1,R2                    ; set port E clock enable bit in SIM_SCGC5 connecting clock to port E
        STR     R1,[R0,#0]                  ; store modified value back into SIM_SCGC5


        ;   Set PTE19 as GPIO
        LDR     R0,=PORTE_PCR19
        LDR     R1,[R0,#0]                      ; load in current Port E Pin 19 Control Register value into R1
        LDR     R2,=PORT_PCR_MUX_SELECT_1_MASK  ; mask to select alt mode 1 (GPIO)
        ORRS    R1,R1,R2                        ; set the MUX bits in PortE PCR to alt 1 (GPIO)
        STR     R1,[R0,#0]                      ; store back to Port E Pin 19 Control Register
        ;   Set PTE19 as output
        LDR     R0,=GPIOE_PDDR
        LDR     R1,[R0,#0]                      ; load in current Port E Pin Direction Register value into R1
        LDR     R2,=0x0008000                   ; mask to set the direction bit for pin #19 (PTE19) to output = 00000000'00001000'00000000'00000000 = 0x0008000
        ORRS    R1,R1,R2                        ; set the direction bit for pin #19 (PTE19) to output
        STR     R1,[R0,#0]                      ; store back to Port E Pin Direction Register

        LDR    R0,=GPIOE_PSOR
        LDR    R1,[R0,#0]
        LDR     R1,[R0,#0]                      ; load in current Port E Set/Clear Output Register value
        LDR     R2,=0x0008000                   ; mask for pin #19 (PTE19) to output = 00000000'00001000'00000000'00000000 = 0x0008000
        ORRS    R1,R1,R2                        ; edit the output bit for mask 
        STR     R1,[R0,#0]                      ; write to Port E Set/Clear Output Register

        POP     {R0-R2}
        BX      LR
        ENDP


    EXPORT      WriteToRedLED
WriteToRedLED     PROC  {R0-R13}
; Description:
;   writes the value of R0 to the onboard red LED
;   if R0 is 0, the LED is turned off
;   if R0 is 1, the LED is turned on
; Inputs:
;   R0 : value to write to the red LED
; Outputs:
;   NONE
; Registers modified:
;   NONE
; Intermediate registers;
;   R0 : value to write to the red LED
;   R1 : GPIO Port E Set/Clear Output Register address
;   R2 : GPIO Port E Set/Clear Output Register value

        PUSH    {R0-R2}

        CMP     R0,#0
        BEQ     WriteToRedLED_OFF
WriteToRedLED_ON     
        LDR     R0,=GPIOE_PCOR
        B       WriteToRedLED_END
WriteToRedLED_OFF 
        LDR     R0,=GPIOE_PSOR
        ;B       WriteToRedLED_END
WriteToRedLED_END
        LDR     R1,[R0,#0]                      ; load in current Port E Set/Clear Output Register value
        LDR     R2,=0x20000000                  ; mask for the set output bit for pin #29 (PTE29). 00100000'00000000'00000000'00000000 = 0x20000000
        ORRS    R1,R1,R2                        ; set the output bit for pin #29 (PTE29) to 1
        STR     R1,[R0,#0]                      ; store back to Port E Set/Clear Output Register

        POP     {R0-R2}
        BX      LR
        ENDP



    EXPORT      WriteToGreenLED
WriteToGreenLED     PROC  {R0-R13}
; Description:
;   writes the value of R0 to the onboard green LED
;   if R0 is 0, the LED is turned off
;   if R0 is 1, the LED is turned on
; Inputs:
;   R0 : value to write to the green LED
; Outputs:
;   NONE
; Registers modified:
;   NONE
; Intermediate registers;
;   R0 : value to write to the green LED
;   R1 : GPIO Port D Set/Clear Output Register address
;   R2 : GPIO Port D Set/Clear Output Register value


        PUSH    {R0-R3}

        CMP     R0,#0
        BEQ     WriteToGreenLED_OFF
WriteToGreenLED_ON     
        LDR     R0,=GPIOD_PCOR                  
        B       WriteToGreenLED_END
WriteToGreenLED_OFF 
        LDR     R0,=GPIOD_PSOR
        ;B       WriteToGreenLED_END
WriteToGreenLED_END
        LDR     R1,[R0,#0]                      ; load in current Port D Set/Clear Output Register value
        MOVS    R2,#0x20                         ; mask for pin #5 (PTD5) = 00000000'00000000'00000000'00100000 = 0x20 = 32
        ORRS    R1,R1,R2                        ; set the output bit for pin #5 (PTD5) to 1,
        STRB    R1,[R0,#0]                      ; store back to Port D Set/Clear Output Register

        POP     {R0-R3}
        BX      LR
        ENDP




        ;get subroutine dependencies
        GET     SubroutineDependencies.s
    ;q: do I want to add an end directive to imported files?
;>>>>>   end subroutine code <<<<<
            ALIGN
;**********************************************************************
;Constants
            AREA    MyConst,DATA,READONLY
;>>>>> begin constants here <<<<<
;>>>>>   end constants here <<<<<
;**********************************************************************
;Variables
            AREA    MyData,DATA,READWRITE
;>>>>> begin variables here <<<<<

Count           SPACE   4
RunStopWatch    SPACE   1
    ALIGN
PutNumUTempString	            SPACE		8	
PutNumUTempStringPast
            
;RX/TX Interupt based UART Queues 
TXQueueRecordStructure   		SPACE     	QueueMGMTRecordSize
TXQueueBuffer					SPACE		UARTQueueBufferSize

	ALIGN

RXQueueRecordStructure   		SPACE     	QueueMGMTRecordSize
RXQueueBuffer					SPACE		UARTQueueBufferSize


;>>>>>   end variables here <<<<<
            END
