/*********************************************************************/
/* <Your program description here>                                   */
/* Name:  <Your name here>                                           */
/* Date:  <Date completed>                                           */
/* Class:  CMPE 250                                                  */
/* Section:  <Your section here>                                     */
/*-------------------------------------------------------------------*/
/* Template:  R. W. Melton                                           */
/*            March 30, 2018                                         */
/*********************************************************************/
#include "MKL46Z4.h"
#include "Exercise12_C.h"

#define FALSE      (0)
#define TRUE       (1)

#define MAX_STRING (79)


/*-------------------------------------------------------------------*/
//function prototypes
UInt8 RandomNibble(void);
UInt8 ASCII_To_Int(char);
char int_To_ASCII(UInt8);


/*-------------------------------------------------------------------*/



int main (void) {

	__asm("CPSID   I");  /* mask interrupts */
	/* Perform all device initialization here Before unmasking interrupts */

	//todo: fix capitalization on initOnboardLEDs to InitOnboardLEDs
	initOnboardLEDs();
	initBinaryLEDs();
	Init_UART0_IRQ ();
	Init_PIT_IRQ ();
  	__asm("CPSIE   I");  /* unmask interrupts */
  while (TRUE){
	WriteToGreenLED(0);
	WriteToRedLED(0);
	writeToBinaryLEDs(0);




  	char user_string[MAX_STRING];
	char userInputChar = '\0';
	UInt8 userInputInt = 0;
  	UInt32 userInputTime = 0;
	float 	userInputTimeSeconds = 0;
	unsigned int *stopWatchCountPtr = GetStopWatchCountAddress();

	/** stopWatchCount is the time in seconds *0.01 since start. 
	 * It is updated by the PIT interrupt handler */
	//unsigned int stopWatchCount = *stopWatchCountPtr; //q: is stopWatchCount now pointing to stopWatchCountAddress?
	
	UInt8 gameRound = 0;
	
	UInt8 magicNumber = 0xF0;
	UInt8 numberCorrect = 0;
	float totalUserInputTime = 0;

	int devMode = FALSE;
	int cheatMode = FALSE;

	while (devMode){

		PutStringSB("Enter a '1' to turn on the LEDs, a '0' to turn them off: \r\n", 61);
		char userChar;
		UInt8 userInput;
		userChar = GetChar();
		userInput = (UInt8) (userChar - '0');

		WriteToRedLED(userInput);
		WriteToGreenLED(userInput);
		if (userInput == 1)
		{
			PutStringSB("You entered a '1'\r\n", 20);
			writeToBinaryLEDs(0x0F);
		}
		else if (userInput == 0)
		{
			PutStringSB("You entered a '0'\r\n", 20);
			writeToBinaryLEDs(0x00);
		}
		else if (userInput == 9){
			PutStringSB("You entered a '9'. Turning off dev mode. \r\n", 44);
			devMode = FALSE;
		}
		else
		{
			PutStringSB("You entered an invalid character\r\n", 35);
		}
		
	}
	


	
		
	
	
	PutStringSB("\r\n\r\n\r\n\r\n\r\n\r\n", 13);
	PutStringSB("			Welcome to Lab 12!\r\n", 31);
	PutStringSB("Enter the hex code of what is displayed on the LEDs in binary within 5 seconds\r\n", 81);
	PutStringSB("for example, if the LEDs are displaying [On][Off][On][Off] = 1010, enter 'A'\r\n", 80);
  	//time in seconds * 0.01 
	while (gameRound<10) { /* game loop*/
		writeToBinaryLEDs(0);
		PutStringSB("Press any key to start the round ", 34);
		StartStopWatch(); //q: do i need to start and stop the stopwatch here? will i still get PIT interrupts when the stopwatch is stopped?
		GetChar();
		PauseStopWatch();
		magicNumber = RandomNibble(); 	// random number based on round start time in nanoseconds 
		*stopWatchCountPtr = 0;			// reset stopwatch count


		if(cheatMode){
			PutStringSB("The magic number was: ", 23);
			PutChar( int_To_ASCII(magicNumber));
			PutStringSB("\r\n", 3);
		}

		writeToBinaryLEDs(magicNumber); 


		//q: how can i make the program automatically advance after 5 seconds? interupts based getchar input? implement getchar in c in a loop? that checks 
		// turn on both LEDs while waiting for use input
		WriteToGreenLED(1);  
		WriteToRedLED(1);
		PutStringSB(" - Round Started, enter your guess within 5 seconds\r\n", 54);
		StartStopWatch();
		userInputChar = GetChar();				// wait for user input
		userInputTime = PauseStopWatch();		//  test assembly 
		userInputTimeSeconds = userInputTime * 0.01;

		userInputInt = ASCII_To_Int(userInputChar);

		PutStringSB("Your input '", 13);
		//PutChar( int_To_ASCII(userInputInt)); // verify int to ascii conversion
		PutChar(userInputChar);
		PutStringSB("' took: ",9);
		PutNumUB(userInputTimeSeconds);
		PutStringSB(" seconds \r\n", 12);

		if (userInputInt == magicNumber ) {
			if (userInputTimeSeconds <= 5){
				PutStringSB("You got it!\r\n", 14);
				//turn on green LED to indicate correct answer
				WriteToGreenLED(1);
				WriteToRedLED(0);
				numberCorrect++;
			}
			else {
				PutStringSB("You got it, but it took you too long.\r\n", 40);
			}


		} else {
			PutStringSB("You got it wrong!\r\n", 20);
			//turn on red LED to indicate incorrect answer
			WriteToGreenLED(0);
			WriteToRedLED(1);

			while (userInputTimeSeconds <= 5 && userInputInt != magicNumber){
				PutStringSB("     You still have time! Guess again quick! \r\n", 48);  // second try with more time
				StartStopWatch();
				userInputChar = GetChar();				// wait for user input
				userInputTime = PauseStopWatch();		//  test assembly 
				userInputTimeSeconds = userInputTime * 0.01;
				userInputInt = ASCII_To_Int(userInputChar);
				PutStringSB("     Your input '", 18);
				//PutChar( int_To_ASCII(userInputInt)); // verify int to ascii conversion
				PutChar(userInputChar);
				PutStringSB("' took: ",9);
				PutNumHex(userInputTimeSeconds);
				PutStringSB(" seconds \r\n", 12);

				if (userInputInt == magicNumber ) {
					if (userInputTimeSeconds <= 5){
						PutStringSB("     Wow You got it!\r\n", 23);
						//turn on green LED to indicate correct answer
						WriteToGreenLED(1);
						WriteToRedLED(0);
						numberCorrect++;
					}
					else { // wrong on second try 
						PutStringSB("     TOO SLOW \r\n", 17);
						WriteToGreenLED(0);
						WriteToRedLED(1);
					}
				}
			}
			PutStringSB("The magic number was: ", 23);
			PutChar( int_To_ASCII(magicNumber));
			PutStringSB("\r\n", 3);
		}
		totalUserInputTime += userInputTimeSeconds;
		PutStringSB("\r\n\r\n", sizeof("\r\n\r\n"));
		gameRound++;
  	}
		PutStringSB("You have completed 10 rounds!\r\n", 32);

		PutStringSB(" You got ", 13);
		PutNumUB(numberCorrect);
		PutStringSB(" correct answers!\r\n", 20);

		PutStringSB(" Your total time was: ", 25);
		UInt8 totalTimeOutput = (UInt8) (totalUserInputTime);
		PutNumUB(totalTimeOutput);
		PutStringSB(" seconds. \r\n", 13);

		PutStringSB(" You took ", 11);
		int percentOfTotalTimeTaken = (int) ((totalUserInputTime ) * 2);
		PutNumUB(percentOfTotalTimeTaken);
		PutStringSB("% of total allowed time. \r\n", 28);


		PutStringSB(" You got ", 10);
		int percentCorrect = (int) ((numberCorrect * 100) /10);
		PutNumUB(percentCorrect);
		PutStringSB("% correct. \r\n", 14);


		PutStringSB(" your score was: ", 18);
		int userScore = 0.8 * percentCorrect + 0.2 * percentOfTotalTimeTaken;
		PutNumUB(userScore);
		PutStringSB("% \r\n", 7);


		PutStringSB("Thanks for playing!\r\n", 22);
		PutStringSB("\r\n", sizeof("\r\n"));
	//gameRound = 0;
 
  }
   return (0);
} /* main */



//*****************************************************************************
//begin methods 
 
 /**
  * outputs a random number between 0x0 and 0xF 
  */
 UInt8 RandomNibble(void){
	return (UInt8)((PIT -> CHANNEL[0].CVAL ) & 0x0F);
	
 }




/**
 * Converts a upper or lower case ascii character to an int
 * @param ascii character to convert
 * @return int value of the ascii character
 */ 
 UInt8 ASCII_To_Int(char ascii){
	 UInt8 intValue = 0;
	 if (ascii >= '0' && ascii <= '9'){
		 intValue = (UInt8) (ascii - '0');
	 } else if (ascii >= 'A' && ascii <= 'F'){
		 intValue = (UInt8) (ascii - 'A' + 10);
	 } else if (ascii >= 'a' && ascii <= 'f'){
		 intValue = (UInt8) (ascii - 'a' + 10);
	 }
	 return intValue;
 }

/**
 * converts an ascii char to upper case
 * @param ascii char to convert
 * @return upper case char
 */
char ASCII_To_Upper(char ascii){
	 if (ascii >= 'a' && ascii <= 'z'){
		 ascii = (char) (ascii - 'a' + 'A');
	 }
	 return ascii;
 }

char int_To_ASCII(UInt8 intValue){
	 char ascii = '0';
	 if (intValue <= 9){
		 ascii = (char) (intValue + '0');
	 } else if (intValue >= 10 && intValue <= 15){
		 ascii = (char) (intValue - 10 + 'A');
	 }
	 return ascii;
 }
  //q: do we ever use maloc? 
